GridSampler (ZXing 3.5.0 API)

com.google.zxing.common

## Class GridSampler

- java.lang.Object
- - com.google.zxing.common.GridSampler

- Direct Known Subclasses:
    DefaultGridSampler

      public abstract class GridSampler
      extends Object

  Implementations of this class can, given locations of finder patterns for a QR code in an image, sample the right points in the image to reconstruct the QR code, accounting for perspective distortion. It is abstracted since it is relatively expensive and should be allowed to take advantage of platform-specific optimized implementations, like Sun's Java Advanced Imaging library, but which may not be available in other environments such as J2ME, and vice versa. The implementation used can be controlled by calling `setGridSampler(GridSampler)` with an instance of a class which implements this interface.
  Author:
    Sean Owen

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GridSampler()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static void` | `checkAndNudgePoints(BitMatrix image, float[] points)` Checks a set of points that have been transformed to sample points on an image against the image's dimensions to see if the point are even within the image.
    `static GridSampler` | `getInstance()`
    `abstract BitMatrix` | `sampleGrid(BitMatrix image, int dimensionX, int dimensionY, float p1ToX, float p1ToY, float p2ToX, float p2ToY, float p3ToX, float p3ToY, float p4ToX, float p4ToY, float p1FromX, float p1FromY, float p2FromX, float p2FromY, float p3FromX, float p3FromY, float p4FromX, float p4FromY)` Samples an image for a rectangular matrix of bits of the given dimension.
    `abstract BitMatrix` | `sampleGrid(BitMatrix image, int dimensionX, int dimensionY, PerspectiveTransform transform)`
    `static void` | `setGridSampler(GridSampler newGridSampler)` Sets the implementation of GridSampler used by the library.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GridSampler

          public GridSampler()

  - ### Method Detail

    - #### setGridSampler

          public static void setGridSampler(GridSampler newGridSampler)

      Sets the implementation of GridSampler used by the library. One global instance is stored, which may sound problematic. But, the implementation provided ought to be appropriate for the entire platform, and all uses of this library in the whole lifetime of the JVM. For instance, an Android activity can swap in an implementation that takes advantage of native platform libraries.
      Parameters:
        `newGridSampler` - The platform-specific object to install.

    - #### getInstance

          public static GridSampler getInstance()

      Returns:
        the current implementation of GridSampler

    - #### sampleGrid

          public abstract BitMatrix sampleGrid(BitMatrix image,
                                               int dimensionX,
                                               int dimensionY,
                                               float p1ToX,
                                               float p1ToY,
                                               float p2ToX,
                                               float p2ToY,
                                               float p3ToX,
                                               float p3ToY,
                                               float p4ToX,
                                               float p4ToY,
                                               float p1FromX,
                                               float p1FromY,
                                               float p2FromX,
                                               float p2FromY,
                                               float p3FromX,
                                               float p3FromY,
                                               float p4FromX,
                                               float p4FromY)
                                        throws NotFoundException

      Samples an image for a rectangular matrix of bits of the given dimension. The sampling transformation is determined by the coordinates of 4 points, in the original and transformed image space.
      Parameters:
        `image` - image to sample
        `dimensionX` - width of `BitMatrix` to sample from image
        `dimensionY` - height of `BitMatrix` to sample from image
        `p1ToX` - point 1 preimage X
        `p1ToY` - point 1 preimage Y
        `p2ToX` - point 2 preimage X
        `p2ToY` - point 2 preimage Y
        `p3ToX` - point 3 preimage X
        `p3ToY` - point 3 preimage Y
        `p4ToX` - point 4 preimage X
        `p4ToY` - point 4 preimage Y
        `p1FromX` - point 1 image X
        `p1FromY` - point 1 image Y
        `p2FromX` - point 2 image X
        `p2FromY` - point 2 image Y
        `p3FromX` - point 3 image X
        `p3FromY` - point 3 image Y
        `p4FromX` - point 4 image X
        `p4FromY` - point 4 image Y
      Returns:
        `BitMatrix` representing a grid of points sampled from the image within a region defined by the "from" parameters
      Throws:
        `NotFoundException` - if image can't be sampled, for example, if the transformation defined by the given points is invalid or results in sampling outside the image boundaries

    - #### sampleGrid

          public abstract BitMatrix sampleGrid(BitMatrix image,
                                               int dimensionX,
                                               int dimensionY,
                                               PerspectiveTransform transform)
                                        throws NotFoundException

      Throws:
        `NotFoundException`

    - #### checkAndNudgePoints

          protected static void checkAndNudgePoints(BitMatrix image,
                                                    float[] points)
                                             throws NotFoundException

      Checks a set of points that have been transformed to sample points on an image against the image's dimensions to see if the point are even within the image.

      This method will actually "nudge" the endpoints back onto the image if they are found to be barely (less than 1 pixel) off the image. This accounts for imperfect detection of finder patterns in an image where the QR Code runs all the way to the image border.

      For efficiency, the method will check points from either end of the line until one is found to be within the image. Because the set of points are assumed to be linear, this is valid.

      Parameters:
        `image` - image into which the points should map
        `points` - actual points in x1,y1,...,xn,yn form
      Throws:
        `NotFoundException` - if an endpoint is lies outside the image boundaries

Copyright © 2007–2022. All rights reserved.